--    Dieses SQL-DDL-Skript wurde von Microsoft Visual Studio (Freigabedatum: LOKALER BUILD) erzeugt.

--    Verwendeter Treiber: Microsoft Visual Studio - Oracle Server-Treiber.
--    Dokument    : D:\Zeichnung1.
--    Zeit zum Erstellen: 02. September 2003 13:27.
--    Operation: Aus Visio-Generierungs-Assistent.
--    Verbundene Datenquelle: Keine  Verbindung.
--    Verbundener Server: Keine  Verbindung.
--    Verbundene Datenbank: Nicht anwendbar.



-- Neue Tabelle VERTEX erstellen.
-- VERTEX : Table of VERTEX  
create table VERTEX (
	VERTEX NUMBER(12,0) not null,
	WORLD_LONG NUMBER(11,3) default 0 not null,
	WORLD_LAT NUMBER(11,3) default 0 not null,
	WORLD_ELEV NUMBER(11,3) default 0 not null,
	ELEMENT NUMBER(12,0) not null, constraint VERTEX_PK primary key (VERTEX) ); 

-- Neue Tabelle UNITVERSION erstellen.
-- UNITVERSION : Table of UNITVERSION  
create table UNITVERSION (
	UNITVERSION NUMBER(12,0) not null,
	VERSIONNUMBER NUMBER(12,0) default 0 not null,
	VERSIONDATE DATE not null,
	UNIT NUMBER(12,0) not null,
	STATE NUMBER(2,0) not null,
	"COMMENT" VARCHAR2(256) default 'Created' null, constraint UNITVERSION_PK primary key (UNITVERSION) ); 


-- Neue Tabelle IMAGEVERSION erstellen.
create table IMAGEVERSION (IMAGEVERSION NUMBER(12,0) not null,
	VERSIONNUMBER NUMBER(12,0) default 0 not null,
	VERSIONDATE DATE not null,
	"COMMENT" VARCHAR2(256) default 'Created' null,
	constraint IMAGEVERSION_PK primary key (IMAGEVERSION) ); 

-- Neue Tabelle AREAVERSION erstellen.
create table AREAVERSION (AREAVERSION NUMBER(12,0) not null,
	VERSIONNUMBER NUMBER(12,0) default 0 not null,
	VERSIONDATE DATE not null,
	"COMMENT" VARCHAR2(256) default 'Created' null,
	STATE NUMBER(2,0) default 1 not null,
	constraint AREAVERSION_PK primary key (AREAVERSION) ); 

-- Neue Tabelle UNITGIS erstellen.
-- UNITGIS : Table of UNITGIS  
create table UNITGIS (
	GISKEY VARCHAR2(64) not null,
	UNIT NUMBER(12,0) not null,
	STREET_NUMBER_INT NUMBER(10,0) null); 

-- Neue Tabelle UNITEXPORT erstellen.
-- UNITEXPORT : Table of UNITEXPORT  
create table UNITEXPORT (
	LOD NUMBER(2,0) not null,
	TYPE NUMBER(2,0) not null,
	EXPORTDATA NUMBER(12,0) not null,
	UNIT NUMBER(12,0) not null); 

-- Neue Tabelle UNIT erstellen.
-- UNIT : Table of UNIT  
create table UNIT (
	UNIT NUMBER(12,0) not null,
	WORLD_LONG NUMBER(11,3) not null,
	WORLD_LAT NUMBER(11,3) not null,
	WORLD_ELEV NUMBER(11,3) not null,
	UNIT_NUMBER NUMBER(9,0) null,
	NAMEN VARCHAR2(255) null,
	WEB_DESCRIPTION CLOB null,
	WEB_LINK VARCHAR2(255) null,
	UNITID VARCHAR2(255) not null, 
	BUILTUPAREA NUMBER(11,3) not null, 
	BIN_BUILTUPAREA BLOB not null, 
	LICSTATE VARCHAR2(6) not null, 
	BIN_LICSTATE BLOB not null, 
	constraint PK_UNIT2 primary key (UNIT) ); 

-- Neue Tabelle TEXTURE erstellen.
-- TEXTURE : Table of TEXTURE  
create table TEXTURE (
	TEXTURE NUMBER(12,0) not null,
	IMAGE NUMBER(12,0) null,
	COLOR NUMBER(12,0) null,
	TRANSPARENCY NUMBER(4,3) default 0 not null,
	DEF NUMBER(1,0) null,
	ELEMENT NUMBER(12,0) not null, constraint TEXTURE_PK primary key (TEXTURE) ); 

-- Neue Tabelle TEXCOORD erstellen.
-- TEXCOORD : Table of TEXCOORD  
create table TEXCOORD (
	TEXCOORD NUMBER(12,0) not null,
	ELEMENT NUMBER(12,0) not null,
	X NUMBER(15,7) not null,
	Y NUMBER(15,7) not null, constraint PK_TEXCOORD62 primary key (TEXCOORD) ); 

-- Neue Tabelle SCANSERIES erstellen.
-- SCANSERIES : Table of SCANSERIES  
-- Neue Tabelle OBJECTCLASS erstellen.
-- OBJECTCLASS : Table of OBJECTCLASS  
create table OBJECTCLASS (
	OBJECTCLASS NUMBER(3,0) not null,
	DESCRIPTION VARCHAR2(255) null, constraint PK_OBJECTCLASS4 primary key (OBJECTCLASS) ); 

-- Neue Tabelle OBJECT erstellen.
-- OBJECT : Table of OBJECT  
create table OBJECT (
	OBJECT NUMBER(9,0) not null,
	UNIT NUMBER(12,0) not null,
	OBJECTCLASS NUMBER(3,0) not null,
	WORLD_LONG NUMBER(11,3) default 0 not null,
	WORLD_LAT NUMBER(11,3) default 0 not null,
	WORLD_ELEV NUMBER(11,3) default 0 not null,
	UNITVERSION NUMBER(12,0) not null, 
	OBJECTID VARCHAR2(256) null, constraint OBJECT_PK primary key (OBJECT) ); 

-- Neue Tabelle ELEMENTCOMPLEX erstellen.
create table ELEMENTCOMPLEX (
	ELEMENTCOMPLEX NUMBER(12,0) not null,
	OBJECT NUMBER(9,0) not null,
	PARENT NUMBER(12,0) null,
	COMPLEXCLASS VARCHAR2(256) null,
	ELEV_LOD_BLOCK NUMBER(11,3) null,
	DEPTH_UNDER_TERRAIN number(11,3) default 0 not null,
	BOUNDARY BLOB null,
	BOUNDARY_SIZE NUMBER(5,0) null,
	constraint ELEMENTCOMPLEX_PK primary key (ELEMENTCOMPLEX),
	constraint OBJECT_FK foreign key (OBJECT) references OBJECT(OBJECT) ); 

-- Neue Tabelle MODELUNIT erstellen.
-- MODELUNIT : Table of MODELUNIT
-- 	ELEV_SHIFT : derives from elevation difference between master area and model area (generalization)  
create table MODELUNIT (
	MODEL NUMBER(6,0) not null,
	ELEV_SHIFT NUMBER(8,3) null,
	UNIT NUMBER(12,0) not null); 

-- Neue Tabelle MODEL erstellen.
-- MODEL : Table of MODEL  
create table MODEL (
	MODEL NUMBER(6,0) not null,
	NAMEN VARCHAR2(255) null,
	constraint MODEL_PK primary key (MODEL) ); 

-- Neue Tabelle LOD erstellen.
-- LOD : Table of LOD  
create table LOD (
	LOD NUMBER(2,0) not null,
	NAME VARCHAR2(255) null, constraint LOD_PK primary key (LOD) ); 

-- Neue Tabelle INTERIORORIENTATION erstellen.
-- INTERIORORIENTATION : Table of INTERIORORIENTATION  
create table INTERIORORIENTATION (
	INTERIORORIENTATION NUMBER(12,0) not null,
	FOCAL_LENGTH NUMBER(10,5) not null,
	IRP_X NUMBER(10,5) not null,
	IRP_Y NUMBER(10,5) not null,
	CAMERA VARCHAR2(256) null,
	CALIBRATION_DATE DATE null, constraint INTERIORORIENTATION_PK primary key (INTERIORORIENTATION) ); 

-- Neue Tabelle mit Installationsinfos + Lizenz (wird nur eine einzige Zeile haben) erstellen
create table INST_INFO (
	SCHEMA_VERSION NUMBER(2,1) not null,
	LICENSE_KEY BLOB,
	APP_KEY_COOKIE BLOB,
	TEXTURE_PATH VARCHAR2(260) not null,
	GUID VARCHAR2(36) null,
	BIN_GUID BLOB null,
	BUILTUP_AREA_LOD1 BLOB null,
	BUILTUP_AREA_LOD2 BLOB null,
	BUILTUP_AREA_LOD3 BLOB null,
	BUILTUP_AREA_TEX BLOB null);

-- Neue Tabelle PENDING_ACTIONS erstellen
create table PENDING_ACTIONS (
	TITLE NUMBER(8,0) not null,
	MESSAGE NUMBER(8,0) not null,
	MSG_BOX_BUTTONS NUMBER(2,0) not null );

-- Neue Tabelle UNIT_OCTREE erstellen.
create table UNIT_OCTREE (
	PAGE NUMBER(12,0) not null,
	LEV NUMBER(12,0) not null,
	PARENT NUMBER(12,0) not null,
	USEDSPACE NUMBER(12,0) not null,
	BRANCHES BLOB not null,
	constraint UNIT_TREE_PAGE_UNIQUE unique(PAGE) );

-- Neue Tabelle IMGPYRAMIDLEVEL erstellen.
-- IMGPYRAMIDLEVEL : Table of IMGPYRAMIDLEVEL  
create table IMGPYRAMIDLEVEL (
	RESOLUTION NUMBER(9,0) not null, constraint PK_IMGPYRAMIDLEVEL primary key (RESOLUTION) ); 

-- Neue Tabelle IMGPYRAMID erstellen.
-- IMGPYRAMID : Table of IMGPYRAMID  
create table IMGPYRAMID (
	DIM_X NUMBER(6,0) not null,
	DIM_Y NUMBER(6,0) not null,
	CONTENT BLOB null,
	RESOLUTION NUMBER(9,0) null,
	IMAGE NUMBER(12,0) not null); 

-- Neue Tabelle IMGORIENTATIONCONNECT erstellen.
-- IMGORIENTATIONCONNECT : Table of IMGORIENTATIONCONNECT  
create table IMGORIENTATIONCONNECT (
	IMGORIENTATIONCONNECT NUMBER(12,0) not null,
	IMGORIENTATION NUMBER(12,0) not null,
	EXTERIORORIENTATION NUMBER(12,0) not null,
	INTERIORORIENTATION NUMBER(12,0) null,
	AFFINETRAFO NUMBER(12,0) not null, constraint IMGORIENTATIONCONNECT_PK primary key (IMGORIENTATIONCONNECT) ); 

-- Neue Tabelle IMGORIENTATION erstellen.
-- IMGORIENTATION : Table of IMGORIENTATION  
create table IMGORIENTATION (
	IMAGE NUMBER(12,0) not null,
	IMGORIENTATION NUMBER(12,0) not null,
	PROJTYPE NUMBER(2,0) default 0 not null,
	SCANOFFSET_X NUMBER(11,3) null,
	SCANOFFSET_Y NUMBER(11,3) null,
	SUBIMAGEOFFSET_X NUMBER(11,3) null,
	SUBIMAGEOFFSET_Y NUMBER(11,3) null,
	ORTHO_CENTREOFFSET_X NUMBER(11,3) null,
	ORTHO_CENTREOFFSET_Y NUMBER(11,3) null,
	ORTHO_PIXELSIZE NUMBER(9,0) null, constraint IMGORIENTATION_PK primary key (IMGORIENTATION) );

-- Neue Tabelle IMAGE erstellen.
-- IMAGE : Table of IMAGE  
create table IMAGE (
	IMAGE NUMBER(12,0) not null,
	RESOLUTION NUMBER(9,0) not null,
	TYPE NUMBER(2,0) not null,
	DESCRIPTION CLOB null,
	NAMEN VARCHAR2(256) null,
	PREVIEW BLOB null,
	REFERENCE VARCHAR2(256) null, 
	IMAGEVERSION NUMBER(12,0) not null, 
	NEAR_PLANE_DIST NUMBER(12,3) null, 
	FAR_PLANE_DIST NUMBER(12,3) null, 
	VALID_PHOTO_WIDTH NUMBER(12,3) null, 
	VALID_PHOTO_HEIGHT NUMBER(12,3) null, 
	TEXTURE_CREATOR NUMBER(2,0) null, 
	constraint IMAGE_PK primary key (IMAGE) ); 

-- Neue Tabelle FACE erstellen.
-- FACE : Table of FACE  
create table FACE (
	FACE NUMBER(12,0) not null,
	VERTEX1 NUMBER(9,0) null,
	VERTEX2 NUMBER(9,0) null,
	VERTEX3 NUMBER(9,0) null,
	ELEMENT NUMBER(12,0) not null,
	TEXTURE NUMBER(12,0) null,
	TEXCOORD1 NUMBER(9,0) null,
	TEXCOORD2 NUMBER(9,0) null,
	TEXCOORD3 NUMBER(9,0) null, constraint FACE_PK primary key (FACE) ); 

-- Neue Tabelle EXTRUSION erstellen.
-- EXTRUSION : Table of EXTRUSION
-- 	EXTRUSION_TYPE : A= Extrude to area
-- 	P= Extrude to parent element  
create table EXTRUSION (
	DIR_LONG NUMBER(5,4) not null,
	DIR_LAT NUMBER(5,4) not null,
	DIR_ELEV NUMBER(5,4) not null,
	EXTRUSION_TYPE CHAR(1) not null,
	ELEMENT NUMBER(12,0) not null, constraint PK_EXTRUSION1 primary key (ELEMENT) ); 

-- Neue Tabelle EXTERIORORIENTATION erstellen.
-- EXTERIORORIENTATION : Table of EXTERIORORIENTATION  
create table EXTERIORORIENTATION (
	EXTERIORORIENTATION NUMBER(12,0) not null,
	ERP_X NUMBER(11,3) not null,
	ERP_Y NUMBER(11,3) not null,
	ERP_Z NUMBER(11,3) not null,
	ANGLE_TYPE NUMBER(2,0) not null,
	PRIM_ANGLE NUMBER(10,7) not null,
	SEC_ANGLE NUMBER(10,7) not null,
	TERT_ANGLE NUMBER(10,7) not null, constraint EXTERIORORIENTATION_PK primary key (EXTERIORORIENTATION) );

-- Neue Tabelle EXPORTDATA erstellen.
-- EXPORTDATA : Table of EXPORTDATA  
create table EXPORTDATA (
	EXPORTDATA NUMBER(12,0) not null,
	DATA CLOB not null, constraint EXPORTDATA_PK primary key (EXPORTDATA) ); 

-- Neue Tabelle ELEMENTCLASS erstellen.
-- ELEMENTCLASS : Table of ELEMENTCLASS  
create table ELEMENTCLASS (
	ELEMENTCLASS NUMBER(3,0) not null,
	DESCRIPTION VARCHAR2(255) null, constraint PK_ELEMENTCLASS3 primary key (ELEMENTCLASS) ); 

-- Neue Tabelle ELEMENT erstellen.
-- ELEMENT : Table of ELEMENT
-- 	"ACTION" : 0=Extend Parent  1=Replace Parent
-- 	TYPE : 1=Polygon  2=Surface  3=Extrusion  
create table ELEMENT (
	ELEMENT NUMBER(12,0) not null,
	ELEMENTCOMPLEX NUMBER(12,0) not null,
	TYPE NUMBER(4,0) not null,
	ELEMENTCLASS NUMBER(3,0) not null,
	LOD NUMBER(2,0) not null, 
	LOWERLOD NUMBER(12,0) null, constraint PK_ELEMENT primary key (ELEMENT) ); 

-- Neue Tabelle EDGETO erstellen.
-- EDGETO : Table of EDGETO  
create table EDGETO (
	EDGELINE NUMBER(12,0) not null,
	ORDERING NUMBER(4,0) not null,
	VERTEX NUMBER(12,0) not null); 

-- Neue Tabelle EDGELINE erstellen.
-- EDGELINE : Table of EDGELINE
-- 	TYPE : 0=Structure (normale Dachlinien)  1=Contour (Traufe auen)  2=Cutout (Traufe innen) 3=Footprint (From Extrusion)
-- 	CODE : 100=Traufe  200=First  300=Dach
-- 	500=Grundriss  
create table EDGELINE (
	EDGELINE NUMBER(12,0) not null,
	TYPE NUMBER(4,0) null,
	VERTEX NUMBER(12,0) not null,
	ELEMENT NUMBER(12,0) not null, constraint EDGELINE_PK primary key (EDGELINE) ); 

-- Neue Tabelle USERDEF_EDGETYPE erstellen.
create table USERDEF_EDGETYPE (
	TYPE NUMBER(4,0) not null,
	ELEMENT NUMBER(12,0) not null,
	NAME VARCHAR2(256) not null,
	constraint TYPE_ELEMENT_UNIQUE unique(TYPE,ELEMENT) ); 

-- Neue Tabelle EDGELINECONNECT erstellen.
create table EDGELINECONNECT (
	MASTER NUMBER(12,0) not null,
	SLAVE NUMBER(12,0) not null,
	constraint EDGELINECONNECT_MASTER_FK foreign key (MASTER) references EDGELINE(EDGELINE),
	constraint EDGELINECONNECT_SLAVE_FK foreign key (SLAVE) references EDGELINE(EDGELINE) ); 

-- Neue Tabelle STREET_TEMPLATE erstellen.
-- STREET_TEMPLATE : Table of STREET_TEMPLATE  
create table STREET_TEMPLATE (
	STREET_KEY VARCHAR2(16) not null,
	NAME VARCHAR2(256) not null); 

-- Neue Tabelle ADDRESS_TEMPLATE erstellen.
-- ADDRESS_TEMPLATE : Table of ADDRESS_TEMPLATE  
create table ADDRESS_TEMPLATE (
	OBJECT_ID VARCHAR2(16) not null,
	STREET_KEY VARCHAR2(16) null,
	STREET_NUMBER VARCHAR2(10) null,
	ADR_X NUMBER(11,3) null,
	ADR_Y NUMBER(11,3) null,
	OBJ_X NUMBER(11,3) not null,
	OBJ_Y NUMBER(11,3) not null); 

-- Neue Tabelle BREAKPOINT erstellen.
-- BREAKPOINT : Table of BREAKPOINT  
create table BREAKPOINT (
	BREAKPOINT NUMBER(12,0) not null,
	WORLD_LAT NUMBER(11,3) not null,
	WORLD_LONG NUMBER(11,3) not null,
	WORLD_ELEV NUMBER(11,3) not null,
	AREA NUMBER(11,0) null, constraint BREAKPOINT_PK primary key (BREAKPOINT) ); 

-- Neue Tabelle BREAKLINE erstellen.
-- BREAKLINE : Table of BREAKLINE  
create table BREAKLINE (
	BREAKLINE NUMBER(12,0) not null,
	BREAKPOINT_START NUMBER(12,0) null,
	BREAKPOINT_END NUMBER(12,0) null,
	AREA NUMBER(6,0) null, constraint BREAKLINE_PK primary key (BREAKLINE) ); 

-- Neue Tabelle AREAEXPORT erstellen.
-- AREAEXPORT : Table of AREAEXPORT  
create table AREAEXPORT (
	AREA NUMBER(6,0) not null,
	TYPE NUMBER(2,0) not null,
	EXPORTDATA NUMBER(12,0) not null); 

-- Neue Tabelle AREA erstellen.
-- AREA : Table of AREA  
create table AREA (
	AREA NUMBER(12,0) not null,
	REF_LONG NUMBER(11,3) null,
	REF_LAT NUMBER(11,3) null,
	DELTA_LONG NUMBER(11,3) null,
	DELTA_LAT NUMBER(11,3) null,
	DIM_LONG NUMBER(11,0) null,
	DIM_LAT NUMBER(11,0) null,
	DTM_POINTCOUNT NUMBER(11,0) null,
	DTM_TRIANGLECOUNT NUMBER(11,0) null,
	PARENT NUMBER(6,0) null,
	ELEVATIONGRID BLOB null,
	DTM_POINTS BLOB null,
	DTM_TEXTURECOORDINATES BLOB null,
	DTM_TRIANGLES BLOB null,
	NAMEN VARCHAR2(255) null, 
	AREAVERSION NUMBER(12,0) not null,
	BBOX_MINX NUMBER(12,3) not null,
	BBOX_MINY NUMBER(12,3) not null,
	BBOX_MINZ NUMBER(12,3) not null,
	BBOX_MAXX NUMBER(12,3) not null,
	BBOX_MAXY NUMBER(12,3) not null,
	BBOX_MAXZ NUMBER(12,3) not null,
	constraint AREA_PK primary key (AREA) ); 

-- Neue Tabelle MODELAREA erstellen.
create table MODELAREA (
	MODEL NUMBER(6,0) not null,
	AREA NUMBER(6,0) not null,
	constraint MODELAREA_MODEL_FK foreign key (MODEL) references MODEL(MODEL),
	constraint MODELAREA_AREA_FK foreign key (AREA) references AREA(AREA) ); 

-- Neue Tabelle MODELIMAGE erstellen.
create table MODELIMAGE (
	MODEL NUMBER(6,0) not null,
	IMAGE NUMBER(12,0) not null,
	TYPE NUMBER(2,0) not null,
	constraint MODELIMAGE_MODEL_FK foreign key (MODEL) references MODEL(MODEL),
	constraint MODELIMAGE_IMAGE_FK foreign key (IMAGE) references IMAGE(IMAGE) ); 

-- Neue Tabelle AFFINETRAFO erstellen.
create table AFFINETRAFO (
	AFFINETRAFO NUMBER(12,0) not null,
	A0 NUMBER(16,8) not null,
	B0 NUMBER(16,8) not null,
	C0 NUMBER(16,8) not null,
	A1 NUMBER(16,8) not null,
	B1 NUMBER(16,8) not null,
	C1 NUMBER(16,8) not null, constraint AFFINETRAFO_PK primary key (AFFINETRAFO) ); 

-- Neue Tabelle COLOR erstellen.
create table COLOR (
	COLOR NUMBER(12,0) not null,
	RED NUMBER(8,7) default 0 not null,
	GREEN NUMBER(8,7) default 0 not null,
	BLUE NUMBER(8,7) default 0 not null,
	constraint COLOR_PK primary key (COLOR) );


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle VERTEX hinzufgen.
create index IX_VERTEX_ELEMENT on VERTEX (
	ELEMENT ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle UNITVERSION hinzufgen.
create index IX_UNITVERSION_UNIT on UNITVERSION (
	UNIT ASC); 


create unique index IX_UNITVERSION_VERSIONNUMBER on UNITVERSION (
	UNIT,
	VERSIONNUMBER); 


alter table UNITVERSION add constraint IX_UNITVERSION_VNUMBER_UC1 unique (
	UNIT,
	VERSIONNUMBER); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle UNITEXPORT hinzufgen.
create unique index IX_UNITEXPORT_UNIT on UNITEXPORT (
	UNIT ASC,
	LOD ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle TEXTURE hinzufgen.
create index IX_TEXTURE_ELEMENT on TEXTURE (
	ELEMENT ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle TEXCOORD hinzufgen.
create index IX_TEXCOORD_ELEMENT on TEXCOORD (
	ELEMENT ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle OBJECT hinzufgen.
create index IX_OBJECT_UNIT on OBJECT (
	UNIT ASC); 


create index IX_OBJECT_UNITVERSION on OBJECT (
	UNITVERSION ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle ELEMENTCOMPLEX hinzufgen.
create index IX_ELEMENTCOMPLEX_OBJECT on ELEMENTCOMPLEX(
	OBJECT ASC); 

create index IX_ELEMENTCOMPLEX_PARENT on ELEMENTCOMPLEX(
	PARENT ASC); 

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle MODELUNIT hinzufgen.
create index IX_MODELUNIT_MODEL on MODELUNIT (
	MODEL ASC); 


create index IX_MODELUNIT_UNIT on MODELUNIT (
	UNIT ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle INST_INFO_UNIQUE hinzufgen.
alter table INST_INFO add constraint INST_INFO_UNIQUE unique (
	SCHEMA_VERSION);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle FACE hinzufgen.
create index FACE_ELEMENT_FK on FACE (
	ELEMENT ASC); 

create index FACE_TEXTURE on FACE (
	TEXTURE ASC); 

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle ELEMENTCLASS hinzufgen.
alter table ELEMENTCLASS add constraint TC_ELEMENTCLASS25 unique (
	DESCRIPTION); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle AREA hinzufgen.
create unique index IX_AREA_AREAVERSION on AREA(AREA,AREAVERSION);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle IMAGE hinzufgen.
create unique index IX_IMAGE_IMAGEVERSION on IMAGE(IMAGE,IMAGEVERSION);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle IMGORIENTATION hinzufgen.
create index IX_IMGORIENTATION_IMAGE on IMGORIENTATION(IMAGE);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle IMGORIENTATIONCONNECT hinzufgen.
create index IX_IMGORICONNECT_IMGORI on IMGORIENTATIONCONNECT(IMGORIENTATION);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle MODELAREA hinzufgen.
create index IX_MODELAREA_MODEL on MODELAREA (MODEL ASC);
create index IX_MODELAREA_AREA on MODELAREA (AREA ASC);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle MODELIMAGE hinzufgen.
create index IX_MODELIMAGE_MODEL on MODELIMAGE (MODEL ASC);
create index IX_MODELIMAGE_IMAGE on MODELIMAGE (IMAGE ASC);

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle ELEMENT hinzufgen.
create index IX_ELEMENT_LOD on ELEMENT (
	ELEMENTCOMPLEX ASC,
	LOD ASC); 

create index IX_ELEMENT_ELEMENTCOMPLEX on ELEMENT (
	ELEMENTCOMPLEX ASC); 

create index IX_ELEMENT_LOWERLOD on ELEMENT (
	LOWERLOD ASC); 

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle EDGETO hinzufgen.
create unique index IX_EDGETO_EDGELINE on EDGETO (
	EDGELINE ASC,
	ORDERING ASC); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle EDGELINE hinzufgen.
create index IX_EDGELINE_ELEMENT on EDGELINE (
	ELEMENT ASC); 

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle USERDEF_EDGETYPE hinzufgen.
create index USERDEF_EDGETYPE_ELEMENT on USERDEF_EDGETYPE (
	ELEMENT ASC); 

-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle STRASSE hinzufgen.
alter table STREET_TEMPLATE add constraint STREET_UC1 unique (
	STREET_KEY); 


-- Verbleibende Schlssel, Abhngigkeiten und Indizes fr Tabelle BREAKLINE hinzufgen.
create index BREAKLINE_AREA_FK on BREAKLINE (
	AREA ASC); 


-- Fremdschlsselabhngigkeiten zu Tabelle VERTEX hinzufgen.
alter table VERTEX
	add constraint FK_VERTEX_ELEMENT foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle UNITVERSION hinzufgen.
alter table UNITVERSION
	add constraint UNIT_UNITVERSION_FK1 foreign key (
		UNIT)
	 references UNIT (
		UNIT); 

-- Fremdschlsselabhngigkeiten zu Tabelle UNITEXPORT hinzufgen.
alter table UNITEXPORT
	add constraint FK_UNITEXPORT_LOD foreign key (
		LOD)
	 references LOD (
		LOD) ON DELETE CASCADE; 

alter table UNITEXPORT
	add constraint FK_UNITEXPORT_UNIT foreign key (
		UNIT)
	 references UNIT (
		UNIT) ON DELETE CASCADE; 

alter table UNITEXPORT
	add constraint FK_UNITEXPORT8 foreign key (
		EXPORTDATA)
	 references EXPORTDATA (
		EXPORTDATA) ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle TEXTURE hinzufgen.
alter table TEXTURE
	add constraint IMAGE_TEXTURE_FK1 foreign key (
		"IMAGE")
	 references "IMAGE" (
		"IMAGE"); 

alter table TEXTURE 
	add constraint FK_TEXTURE_COLOR foreign key (
		COLOR) 
	references COLOR (
		COLOR);

alter table TEXTURE
	add constraint TEXTURE_ELEMENT_FK foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle TEXCOORD hinzufgen.
alter table TEXCOORD
	add constraint FK_TEXCOORD9 foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle OBJECT hinzufgen.
alter table OBJECT
	add constraint FK_OBJECT_UNIT foreign key (
		UNIT)
	 references UNIT (
		UNIT); 

alter table OBJECT
	add constraint OBJECTCLASS_OBJECT_FK1 foreign key (
		OBJECTCLASS)
	 references OBJECTCLASS (
		OBJECTCLASS); 

alter table OBJECT
	add constraint UNITVERSION_OBJECT_FK1 foreign key (
		UNITVERSION)
	 references UNITVERSION (
		UNITVERSION); 

-- Fremdschlsselabhngigkeiten zu Tabelle ELEMENTCOMPLEX hinzufgen.
alter table ELEMENTCOMPLEX
	add constraint PARENT_ELEMENT_FK foreign key (
		PARENT)
		 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle MODELUNIT hinzufgen.
alter table MODELUNIT
	add constraint FK_MODELUNIT_MODEL foreign key (
		MODEL)
	 references MODEL (
		MODEL) ON DELETE CASCADE; 

alter table MODELUNIT
	add constraint FK_MODELUNIT_UNIT foreign key (
		UNIT)
	 references UNIT (
		UNIT) ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle IMGPYRAMID hinzufgen.
alter table IMGPYRAMID
	add constraint FK_IMAGEPYRAMID_IMAGE foreign key (
		"IMAGE")
	 references "IMAGE" (
		"IMAGE") ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle IMGORIENTATIONCONNECT hinzufgen.
alter table IMGORIENTATIONCONNECT
	add constraint FK_IMGORCONN_IMGORIENTATION foreign key (
		IMGORIENTATION)
	 references IMGORIENTATION (
		IMGORIENTATION) ON DELETE CASCADE; 

alter table IMGORIENTATIONCONNECT
	add constraint FK_IMGORCONN_EXTORIENTATION foreign key (
		EXTERIORORIENTATION)
	 references EXTERIORORIENTATION (
		EXTERIORORIENTATION) ON DELETE CASCADE; 

alter table IMGORIENTATIONCONNECT
	add constraint FK_IMGORCONN_INTORIENTATION foreign key (
		INTERIORORIENTATION)
	 references INTERIORORIENTATION (
		INTERIORORIENTATION) ON DELETE CASCADE; 

alter table IMGORIENTATIONCONNECT
	add constraint FK_IMGORCONN_AFFINETRAFO foreign key (
		AFFINETRAFO)
	 references AFFINETRAFO (
		AFFINETRAFO) ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle IMGORIENTATION hinzufgen.
alter table IMGORIENTATION
	add constraint FK_ORIENTATION10 foreign key (
		"IMAGE")
	 references "IMAGE" (
		"IMAGE") ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle FACE hinzufgen.
alter table FACE
	add constraint FACE_ELEMENT foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

alter table FACE
	add constraint FACE_TEXTURE_FK foreign key (
		TEXTURE)
	 references TEXTURE (
		TEXTURE); 

-- Fremdschlsselabhngigkeiten zu Tabelle EXTRUSION hinzufgen.
alter table EXTRUSION
	add constraint EXTRSUSION_ELEMENT foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle ELEMENT hinzufgen.
alter table ELEMENT
	add constraint FK_ELEMENT_ELEMENTCOMPLEX foreign key (
		ELEMENTCOMPLEX)
	 references ELEMENTCOMPLEX (
		ELEMENTCOMPLEX); 

alter table ELEMENT 
	add constraint ELEMENTCLASS_ELEMENT_FK1 foreign key (
		ELEMENTCLASS)
	 references ELEMENTCLASS(
	 	ELEMENTCLASS); 

alter table ELEMENT 
	add constraint FK_ELEMENT_LOWERLOD foreign key (
		LOWERLOD)
	 references ELEMENT(
	 	ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle EDGETO hinzufgen.
alter table EDGETO
	add constraint FK_EDGETO_EDGELINE foreign key (
		EDGELINE)
	 references EDGELINE (
		EDGELINE); 

-- Fremdschlsselabhngigkeiten zu Tabelle EDGELINE hinzufgen.
alter table EDGELINE
	add constraint FK_EDGELINE_ELEMENT foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle USERDEF_EDGETYPE hinzufgen.
alter table USERDEF_EDGETYPE
	add constraint FK_USERDEF_EDGETYPE_ELEMENT foreign key (
		ELEMENT)
	 references ELEMENT (
		ELEMENT); 

-- Fremdschlsselabhngigkeiten zu Tabelle AREAEXPORT hinzufgen.
alter table AREAEXPORT
	add constraint AREA_AREAEXPORT foreign key (
		AREA)
	 references AREA (
		AREA) ON DELETE CASCADE; 

-- Fremdschlsselabhngigkeiten zu Tabelle AREA hinzufgen.
alter table AREA
	add constraint AREA_AREA foreign key (
		PARENT)
	 references AREA (
		AREA) ON DELETE CASCADE; 

alter table AREA
	add constraint FK_AREA_AREAVERSION foreign key (
		AREAVERSION)
	 references AREAVERSION (
		AREAVERSION); 

-- Fremdschlsselabhngigkeiten zu Tabelle IMAGE hinzufgen.
alter table IMAGE
	add constraint FK_IMAGE_IMAGEVERSION foreign key (
		IMAGEVERSION)
	 references IMAGEVERSION (
		IMAGEVERSION); 


-- Erstellen/Erneutes Erstellen von benutzerdefinierten Triggern fr alle neu erstellten und genderten Tabellen.

-- Trigger auf Tabellenebene fr Tabelle EXPORTDATA erstellen.
create or replace trigger "NEW_EXPORTDATA" BEFORE
    INSERT
    ON "EXPORTDATA"
    FOR EACH ROW 




begin
  select ExportData_seq.NEXTVAL into :new.EXPORTDATA from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle OBJECT erstellen.
create or replace trigger "NEW_OBJECT" BEFORE INSERT
    ON "OBJECT"
    FOR EACH ROW 




begin
  select object_seq.NEXTVAL into :new.object from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle ELEMENTCOMPLEX erstellen.
create or replace trigger "NEW_ELEMENTCOMPLEX" BEFORE INSERT
    ON "ELEMENTCOMPLEX"
    FOR EACH ROW 




begin
  select ELEMENTCOMPLEX_SEQ.NEXTVAL into :new.ELEMENTCOMPLEX from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle BREAKPOINT erstellen.
create or replace trigger "NEW_BREAKPOINT" BEFORE
    INSERT
    ON "BREAKPOINT"
    FOR EACH ROW 




begin
  select Breakpoint_seq.NEXTVAL into :new.breakpoint from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle VERTEX erstellen.
create or replace trigger "NEW_VERTEX" BEFORE INSERT
    ON "VERTEX"
    FOR EACH ROW 




begin
  select vertex_seq.NEXTVAL into :new.vertex from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle AREA erstellen.
create or replace trigger "NEW_AREA" BEFORE INSERT
    ON "AREA"
    FOR EACH ROW 




begin
  select area_seq.NEXTVAL into :new.area from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle TEXCOORD erstellen.
create or replace trigger "NEW_TEXCOORD" BEFORE INSERT
    ON "TEXCOORD"
    FOR EACH ROW 




begin
  select texcoord_seq.NEXTVAL into :new.texcoord from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle BREAKLINE erstellen.
create or replace trigger "NEW_BREAKLINE" BEFORE
    INSERT
    ON "BREAKLINE"
    FOR EACH ROW 




begin
  select breakline_seq.NEXTVAL into :new.breakline from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle FACE erstellen.
create or replace trigger "NEW_FACE" BEFORE INSERT
    ON "FACE"
    FOR EACH ROW 




begin
  select face_seq.NEXTVAL into :new.face from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle UNIT erstellen.
create or replace trigger "NEW_UNIT" BEFORE INSERT
    ON "UNIT"
    FOR EACH ROW 




begin
  select unit_seq.NEXTVAL into :new.unit from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle UNITVERSION erstellen.
create or replace trigger "NEW_UNITVERSION" BEFORE INSERT
    ON "UNITVERSION"
    FOR EACH ROW





begin
  select unitversion_seq.NEXTVAL into :new.unitversion from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle IMAGEVERSION erstellen.
create or replace trigger "NEW_IMAGEVERSION" BEFORE INSERT
    ON "IMAGEVERSION"
    FOR EACH ROW





begin
  select IMAGEVERSION_SEQ.NEXTVAL into :new.IMAGEVERSION from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle AREAVERSION erstellen.
create or replace trigger "NEW_AREAVERSION" BEFORE INSERT
    ON "AREAVERSION"
    FOR EACH ROW





begin
  select AREAVERSION_SEQ.NEXTVAL into :new.AREAVERSION from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle ELEMENT erstellen.
create or replace trigger "NEW_ELEMENT" BEFORE INSERT
    ON "ELEMENT"
    FOR EACH ROW 




begin
  select element_seq.NEXTVAL into :new.element from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle MODEL erstellen.
create or replace trigger "NEW_MODEL" BEFORE INSERT
    ON "MODEL"
    FOR EACH ROW 




begin
  select Model_seq.NEXTVAL into :new.MODEL from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle EDGELINE erstellen.
create or replace trigger "NEW_EDGELINE" BEFORE INSERT
    ON "EDGELINE"
    FOR EACH ROW 




begin
  select edgeline_seq.NEXTVAL into :new.edgeline from dual;
end;
/


-- Trigger auf Tabellenebene fr Tabelle IMAGE erstellen.
create or replace trigger "NEW_IMAGE" BEFORE INSERT
    ON "IMAGE"
    FOR EACH ROW 




begin
  select image_seq.NEXTVAL into :new.image from dual;
end;
/



-- Trigger auf Tabellenebene fr Tabelle TEXTURE erstellen.
create or replace trigger "NEW_TEXTURE" BEFORE INSERT
    ON "TEXTURE"
    FOR EACH ROW 




begin
  select texture_seq.NEXTVAL into :new.texture from dual;
end;
/

-- Trigger auf Tabellenebene fr Tabellen der IMG_ORIENTATION erstellen.

CREATE OR REPLACE TRIGGER "NEW_IMGORIENTATION" BEFORE INSERT
    ON "IMGORIENTATION"
    FOR EACH ROW 
    begin
       select IMGORIENTATION_SEQ.NEXTVAL into :new.IMGORIENTATION from dual;
    end;
/

CREATE OR REPLACE TRIGGER "NEW_EXTERIORORIENTATION" BEFORE INSERT
    ON "EXTERIORORIENTATION"
    FOR EACH ROW 
    begin
       select EXTERIORORIENTATION_SEQ.NEXTVAL into :new.EXTERIORORIENTATION from dual;
    end;
/

CREATE OR REPLACE TRIGGER "NEW_INTERIORORIENTATION" BEFORE INSERT
    ON "INTERIORORIENTATION"
    FOR EACH ROW 
    begin
       select INTERIORORIENTATION_SEQ.NEXTVAL into :new.INTERIORORIENTATION from dual;
    end;
/

CREATE OR REPLACE TRIGGER "NEW_AFFINETRAFO" BEFORE INSERT
    ON "AFFINETRAFO"
    FOR EACH ROW 
    begin
       select AFFINETRAFO_SEQ.NEXTVAL into :new.AFFINETRAFO from dual;
    end;
/

CREATE OR REPLACE TRIGGER "NEW_IMGORIENTATIONCONNECT" BEFORE INSERT
    ON "IMGORIENTATIONCONNECT"
    FOR EACH ROW 
    begin
       select IMGORIENTATIONCONNECT_SEQ.NEXTVAL into :new.IMGORIENTATIONCONNECT from dual;
    end;
/

CREATE OR REPLACE TRIGGER NEW_COLOR BEFORE INSERT
	ON COLOR 
    FOR EACH ROW 
    begin
		select COLOR_SEQ.NEXTVAL into :new.COLOR from dual;
    end;
/

-- Ende des von Microsoft Visual Studio erzeugten SQL-DDL-Skripts erreicht.
